# Method: projects.translateText

- [HTTP request](https://docs.cloud.google.com/translate/docs/reference/rest/v3/projects/translateText#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/translate/docs/reference/rest/v3/projects/translateText#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/translate/docs/reference/rest/v3/projects/translateText#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/translate/docs/reference/rest/v3/projects/translateText#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/translate/docs/reference/rest/v3/projects/translateText#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/translate/docs/reference/rest/v3/projects/translateText#body.aspect)
- [Try it!](https://docs.cloud.google.com/translate/docs/reference/rest/v3/projects/translateText#try-it)

Translates input text and returns translated text.

### HTTP request

`POST https://translate.googleapis.com/v3/{parent=projects/*}:translateText`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. Project or location to make a call. Must refer to a caller's project. Format: `projects/{project-number-or-id}` or `projects/{project-number-or-id}/locations/{location-id}`. For global calls, use `projects/{project-number-or-id}/locations/global` or `projects/{project-number-or-id}`. Non-global location is required for requests using AutoML models or custom glossaries. Models and glossaries must be within the same region (have same location-id), otherwise an INVALID_ARGUMENT (400) error is returned. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "contents": [ string ], "mimeType": string, "sourceLanguageCode": string, "targetLanguageCode": string, "model": string, "glossaryConfig": { object (`https://docs.cloud.google.com/translate/docs/reference/rest/v3/TranslateTextGlossaryConfig`) }, "transliterationConfig": { object (`https://docs.cloud.google.com/translate/docs/reference/rest/v3/TransliterationConfig`) }, "labels": { string: string, ... } } ``` |

| Fields ||
|---|---|
| `contents[]` | `string` Required. The content of the input in string format. We recommend the total content be less than 30,000 codepoints. The max length of this field is 1024. Use BatchTranslateText for larger text. |
| `mimeType` | `string` Optional. The format of the source text, for example, "text/html", "text/plain". If left blank, the MIME type defaults to "text/html". |
| `sourceLanguageCode` | `string` Optional. The ISO-639 language code of the input text if known, for example, "en-US" or "sr-Latn". Supported language codes are listed in Language Support. If the source language isn't specified, the API attempts to identify the source language automatically and returns the source language within the response. |
| `targetLanguageCode` | `string` Required. The ISO-639 language code to use for translation of the input text, set to one of the language codes listed in Language Support. |
| `model` | `string` Optional. The `model` type requested for this translation. The format depends on model type: - AutoML Translation models: `projects/{project-number-or-id}/locations/{location-id}/models/{model-id}` - General (built-in) models: `projects/{project-number-or-id}/locations/{location-id}/models/general/nmt`, - Translation LLM models: `projects/{project-number-or-id}/locations/{location-id}/models/general/translation-llm`, For global (non-regionalized) requests, use `location-id` `global`. For example, `projects/{project-number-or-id}/locations/global/models/general/nmt`. If not provided, the default Google model (NMT) will be used Authorization requires one or more of the following [IAM](https://cloud.google.com/iam/docs/) permissions on the specified resource `model`: - `cloudtranslate.generalModels.predict` - `automl.models.predict` |
| `glossaryConfig` | ``object (`https://docs.cloud.google.com/translate/docs/reference/rest/v3/TranslateTextGlossaryConfig`)`` Optional. Glossary to be applied. The glossary must be within the same region (have the same location-id) as the model, otherwise an INVALID_ARGUMENT (400) error is returned. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `glossaryConfig`: - `cloudtranslate.glossaries.predict` |
| `transliterationConfig` | ``object (`https://docs.cloud.google.com/translate/docs/reference/rest/v3/TransliterationConfig`)`` Optional. Transliteration to be applied. |
| `labels` | `map (key: string, value: string)` Optional. The labels with user-defined metadata for the request. Label keys and values can be no longer than 63 characters (Unicode codepoints), can only contain lowercase letters, numeric characters, underscores and dashes. International characters are allowed. Label values are optional. Label keys must start with a letter. See <https://cloud.google.com/translate/docs/advanced/labels> for more information. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/translate/docs/reference/rest/v3/TranslateTextResponse`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `https://www.googleapis.com/auth/cloud-translation`

For more information, see the [Authentication Overview](https://cloud.google.com/docs/authentication/).